/****************************************************************************
 * 이벤트 등록
 ****************************************************************************/
function fn_insertAppEvent(){
    if("Y"!=insertUseYn){
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

    let title          = $("#title").val();
    let content      = $("#content").val();
    let detail         = $("#summernote").summernote('code');
    let eventStartDate  = $("#eventStartDate").val();
    let eventEndDate       = $("#eventEndDate").val();
    let exposedYn      = true===$("#exposedYn").prop('checked')?'Y':'N';
    let file            = $("#file")[0].files[0];

    if(true != fn_emptyCheck(title)) {
        modalEvent.warning("등록", "이벤트 제목을 입력하세요.");
        return;
    }else{
        if(true != fn_lengthCheck(title, 20)) {
            modalEvent.warning("등록", "제목 정보는 20자를 넘을 수 없습니다.");
            return;
        }
    }

    if(true != fn_emptyCheck(content)) {
        modalEvent.warning("등록", "이벤트 내용을 입력하세요.");
        return;
    }else{
        if(true != fn_lengthCheck(content, 20)) {
            modalEvent.warning("등록", "이벤트 내용은 20자를 넘을 수 없습니다.");
            return;
        }
    }
    if(true != fn_emptyCheck(detail)) {
        modalEvent.warning("등록", "이벤트 상세를 입력하세요.");
        return;
    }

    if(true != fn_emptyCheck(eventStartDate)) {
        modalEvent.warning("등록", "이벤트 시작일자를 입력하세요.");
        return;
    }

    if(true != fn_emptyCheck(eventEndDate)) {
        modalEvent.warning("등록", "이벤트 종료일자를 입력하세요.");
        return;
    }

    if(true != fn_emptyCheck(exposedYn)) {
        modalEvent.warning("등록", "메인 홈 노출 정보가 없습니다.");
        return;
    }

    if(true != fn_emptyCheck(file)) {
        modalEvent.warning("등록", "배너이미지 정보가 없습니다.");
        return;
    }

    modalEvent.info("등록", "이벤트 정보를 등록하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("title", title);
        formData.append("content", content);
        formData.append("detail", detail);
        formData.append("eventStartDate", eventStartDate);
        formData.append("eventEndDate", eventEndDate);
        formData.append("exposedYn", exposedYn);
        formData.append("file", file);

        $.ajax({
            url: encodeURI('/webappevent/insertAppEvent.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("등록 성공", data.msgDesc, function(){
                        fn_selectListAppEventIntro();
                    });
                }
                else{
                    modalEvent.danger("등록 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("등록 오류", "등록 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 배너 이미지 미리보기
 ****************************************************************************/
function fn_filePreview(){
   const file =  $("#file")[0].files[0];
   if(file){
       $('.img_box').html('');
       const reader = new FileReader();

       reader.onload = function (e) {
           // 이미지 요소를 생성하고 미리보기 추가
           const img = document.createElement('img');
           img.src = e.target.result;
           img.style.width = '170px'; // 원하는 크기로 조정
           img.style.height = '100px';
           $('.img_box').append(img);
       };

       // 파일을 읽기 시작
       reader.readAsDataURL(file);
   }
}
/****************************************************************************
 * 배너 이미지 삭제
 ****************************************************************************/
function fn_removePreview(){
    $("#file").val('');
    $('.img_box').html('');
}

/****************************************************************************
 * 리스트 화면으로 이동.
 ****************************************************************************/
function fn_selectListAppEventIntro(){
    if("Y"==selectUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webappevent/selectListEventIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }
}

/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#eventStartDate", "#eventEndDate");

    $('#summernote').summernote({height: 600});
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $('.btnCancle').on("click", function(){
        fn_selectListAppEventIntro();
    });

    $('.btnSave').on("click", function(){
        fn_insertAppEvent();
    });
    $('#delete_btn').on("click", function(){
        fn_removePreview();
    });
    $('#file').on('change', function(e) {
        fn_filePreview();
    })
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});